import sys
import traceback
import functools
from PyQt4.QtCore import SIGNAL

def exc2signal(ret_val=None):
    def foo(method):
        @functools.wraps(method)
        def bar(self, *args, **kwargs):
            try:
                return method(self, *args, **kwargs)
            except:
                if hasattr(self, 'setValid'):
                    self.setValid(False)
                info = sys.exc_info()
                for i in ''.join(traceback.format_exception(*info)).splitlines():
                    sys.stderr.write(' \033[38;5;9m*\033[0m %s\n' % i)
                self.emit(SIGNAL('Exception'), info)
                return ret_val
        return bar
    return foo

def check_valid(ret_val=None):
    def foo(method):
        @functools.wraps(method)
        def bar(self, *args, **kwargs):
            if hasattr(self, 'isValid') and not self.isValid():
                return ret_val
            else:
                return method(self, *args, **kwargs)
        return bar
    return foo

