from PyQt4 import QtCore
from contextlib import contextmanager

@contextmanager
def group(settings, group):
    if group is not None:
        settings.beginGroup(group)
        yield
        settings.endGroup()
    else:
        yield

@contextmanager
def read_array(settings, array):
    size = settings.beginReadArray(array)
    yield size
    settings.endArray()

@contextmanager
def write_array(settings, array, size=-1):
    settings.beginWriteArray(array, size)
    yield
    settings.endArray()

