from PyQt4 import QtCore#, QtGui
#from PyQt4.QtCore import Qt
from sysdb.cache import GlobalGroupsCache
from common.gui.TableModel import AbstractColumn, TableModel

class TextColumn(AbstractColumn):
    def __init__(self, attr_name, text, visible=True, width=None, weight=None):
        AbstractColumn.__init__(self, text, visible, width, weight)
        self.__name = attr_name
        self.__cache = GlobalGroupsCache()
    def display_data(self, row):
        u = self.__cache.get(row)
        return QtCore.QVariant(getattr(u, self.__name))

class AllGroupsModel(TableModel):
    def __init__(self, parent=None):
        self.__cache = GlobalGroupsCache()
        # initialise columns
        columns = []
        columns.append(TextColumn('gid', 'gid', False, 40))
        columns.append(TextColumn('name', 'name', weight=1))
        columns.append(TextColumn('description', 'description', weight=3))
        TableModel.__init__(self, columns, parent)
    def count(self):
        return self.__cache.count()

def _run_test():
    import sys
    from PyQt4 import QtGui
    from table import GroupsTableView
    qa = QtGui.QApplication(sys.argv)
    settings = QtCore.QSettings('test.org')
    table = GroupsTableView()
    table.resize(500, 300)
    table.setModel(AllGroupsModel(table))
    table.load(settings)
    table.show()
    qa.exec_()
    table.save(settings)

