from PyQt4 import QtCore
from common.gui.table import TableView

class UsersTableView(TableView):
    def __init__(self, parent=None):
        TableView.__init__(self, parent)
    def get_selected(self):
        sm = self.selectionModel()
        srows = sm.selectedRows(0)
        if len(srows) > 0:
            return [self.model().data(i).toInt()[0] for i in srows]
        else:
            return []
    def save(self):
        settings = QtCore.QSettings()
        TableView.save_state(self, settings, 'Users')
    def load(self):
        settings = QtCore.QSettings()
        TableView.load_state(self, settings, 'Users')
    def setModel(self, model):
        self.save()
        TableView.setModel(self, model)
        self.load()

class GroupsTableView(TableView):
    def __init__(self, parent=None):
        TableView.__init__(self, parent)
    def get_selected(self):
        sm = self.selectionModel()
        srows = sm.selectedRows(0)
        if len(srows) > 0:
            return [self.model().data(i).toInt()[0] for i in srows]
        else:
            return []
    def save(self):
        settings = QtCore.QSettings()
        TableView.save_state(self, settings, 'Groups')
    def load(self):
        settings = QtCore.QSettings()
        TableView.load_state(self, settings, 'Groups')
    def setModel(self, model):
        self.save()
        TableView.setModel(self, model)
        self.load()

